/*---------------------------------------------------------------------------*\
  =========                 |
  \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
   \\    /   O peration     |
    \\  /    A nd           | www.openfoam.com
     \\/     M anipulation  |
-------------------------------------------------------------------------------
    Copyright (C) 2016 OpenFOAM Foundation
-------------------------------------------------------------------------------
License
    This file is part of OpenFOAM.

    OpenFOAM is free software: you can redistribute it and/or modify it
    under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    OpenFOAM is distributed in the hope that it will be useful, but WITHOUT
    ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
    FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
    for more details.

    You should have received a copy of the GNU General Public License
    along with OpenFOAM.  If not, see <http://www.gnu.org/licenses/>.

\*---------------------------------------------------------------------------*/

#include "corforMoment.H"
#include "rigidBodyModel.H"
#include "addToRunTimeSelectionTable.H"

#include <iostream>
#include <fstream>

// * * * * * * * * * * * * * * Static Data Members * * * * * * * * * * * * * //

namespace Foam
{
namespace RBD
{
namespace restraints
{
    defineTypeNameAndDebug(corforMoment, 0);

    addToRunTimeSelectionTable
    (
        restraint,
        corforMoment,
        dictionary
    );
}
}
}


// * * * * * * * * * * * * * * * * Constructors  * * * * * * * * * * * * * * //

Foam::RBD::restraints::corforMoment::corforMoment
(
    const word& name,
    const dictionary& dict,
    const rigidBodyModel& model
)
:
    restraint(name, dict, model)
{
    read(dict);
}


// * * * * * * * * * * * * * * * * Destructor  * * * * * * * * * * * * * * * //

Foam::RBD::restraints::corforMoment::~corforMoment()
{}


// * * * * * * * * * * * * * * Member Functions  * * * * * * * * * * * * * * //

void Foam::RBD::restraints::corforMoment::restrain
(
    scalarField& tau,
    Field<spatialVector>& fx,
    const rigidBodyModelState& state
) const
{
	Info << name() << " is updated. " << endl;
    	std::ofstream ofs(name());
    	if(!ofs){
        	Info << "can't open file. Fatal error. " << endl;
        	std::cin.get();
//        	return;
    	}else{
		vector	a = (model_.X0(bodyID_).inv() && spatialVector(Zero, target_position)).l();
		Tensor<scalar> RrT = model_.X0(bodyID_).E();

		ofs << a.x() << " " << a.y() << " " << a.z() << std::endl;
		ofs << RrT.xx() << " " << RrT.xy() << " " << RrT.xz() << std::endl;
		ofs << RrT.yx() << " " << RrT.yy() << " " << RrT.yz() << std::endl;
		ofs << RrT.zx() << " " << RrT.zy() << " " << RrT.zz() << std::endl << std::endl;
		ofs << "Center of rotation for body coordinate system: x, y, z" << std::endl; 
		ofs << "x axis: xx, xy, xz" << std::endl; 
		ofs << "y axis: yx, yy, yz" << std::endl; 
		ofs << "z axis: zx, zy, zz" << std::endl << std::endl;

		ofs << "Do not remove or modify this file under calculation. The program always overwrites and reads these values." << std::endl; 
	}
}

bool Foam::RBD::restraints::corforMoment::read
(
    const dictionary& dict
)
{
    restraint::read(dict);
    coeffs_.readEntry("target_position", target_position);

    return true;
}


void Foam::RBD::restraints::corforMoment::write
(
    Ostream& os
) const
{
    restraint::write(os);
    os.writeEntry("target_position", target_position);
}


// ************************************************************************* //
